package ${package}.dao.ibatis;

import java.util.List;

import ${package}.dao.GenericDAO;
import ${package}.dao.ibatis.mappers.GenericMapper;
import ${package}.dao.ibatis.session.ConnectionFactory;
import ${package}.dao.ibatis.session.SqlSession;
import ${package}.domain.Identifiable;

class GenericDAOImpl<T extends Identifiable, M extends GenericMapper<T>> implements GenericDAO<T, Long> {

	private Class<M> clazz;

	public GenericDAOImpl(Class<M> clazz) {
		this.clazz = clazz;
	}

	@Override
	public Long create(T object) {
		try (SqlSession session = ConnectionFactory.getSqlSessionFactory().openSession()) {
			session.getMapper(clazz).insert(object);
			session.commit();
			return object.getId();
		}
	}

	@Override
	public T read(Long id) {
		try (SqlSession session = ConnectionFactory.getSqlSessionFactory().openSession()) {
			return session.getMapper(clazz).selectById(id);
		}
	}

	@Override
	public void update(T object) {
		try (SqlSession session = ConnectionFactory.getSqlSessionFactory().openSession()) {
			session.getMapper(clazz).update(object);
			session.commit();
		}
	}

	@Override
	public void delete(Long key) {
		try (SqlSession session = ConnectionFactory.getSqlSessionFactory().openSession()) {
			session.getMapper(clazz).delete(key);
			session.commit();
		}
	}

	@Override
	public List<T> readAll() {
		try (SqlSession session = ConnectionFactory.getSqlSessionFactory().openSession()) {
			return session.getMapper(clazz).selectAll();
		}
	}

}
