package ${package}.dao.ibatis.session;

import java.io.Reader;

import ${package}.config.Settings;

import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;

public final class ConnectionFactory {

	private static SqlSessionFactory sqlSessionFactory;
	private static Reader reader;

	static {
		try {
			reader = Resources.getResourceAsReader(Settings.getInstance().getProperty("db.ibatis.config.name"));

			if (sqlSessionFactory == null) {
				sqlSessionFactory = new SqlSessionFactory(new SqlSessionFactoryBuilder().build(reader, Settings.getInstance()));
				sqlSessionFactory.getConfiguration().addMappers("${package}.dao.ibatis.mappers");
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private ConnectionFactory() { }

	public static SqlSessionFactory getSqlSessionFactory() {
		return sqlSessionFactory;
	}
}
