package ${package}.dao.ibatis.session;

import java.io.Closeable;
import java.sql.Connection;
import java.util.List;
import java.util.Map;

import org.apache.ibatis.executor.BatchResult;
import org.apache.ibatis.session.Configuration;
import org.apache.ibatis.session.ResultHandler;
import org.apache.ibatis.session.RowBounds;

public class SqlSession implements org.apache.ibatis.session.SqlSession, Closeable {

	private org.apache.ibatis.session.SqlSession wrappedSession;

	SqlSession(org.apache.ibatis.session.SqlSession wrappedSession) {
		this.wrappedSession = wrappedSession;
	}

	@Override
	public <T> T  selectOne(String statement) {
		return wrappedSession.selectOne(statement);
	}

	@Override
	public <T> T  selectOne(String statement, Object parameter) {
		return wrappedSession.selectOne(statement, parameter);
	}

	@Override
	public <E> List<E> selectList(String statement) {
		return wrappedSession.selectList(statement);
	}

	@Override
	public <E> List<E> selectList(String statement, Object parameter) {
		return wrappedSession.selectList(statement, parameter);
	}

	@Override
	public <E> List<E> selectList(String statement, Object parameter, RowBounds rowBounds) {
		return wrappedSession.selectList(statement, parameter, rowBounds);
	}

	@Override
	public <K, V> Map<K, V> selectMap(String statement, String mapKey) {
		return wrappedSession.selectMap(statement, mapKey);
	}

	@Override
	public <K, V> Map<K, V> selectMap(String statement, Object parameter, String mapKey) {
		return wrappedSession.selectMap(statement, parameter, mapKey);
	}

	@Override
	public <K, V> Map<K, V> selectMap(String statement, Object parameter, String mapKey, RowBounds rowBounds) {
		return wrappedSession.selectMap(statement, parameter, mapKey, rowBounds);
	}

	@Override
	public void select(String statement, Object parameter, ResultHandler handler) {
		wrappedSession.select(statement, parameter, handler);
	}

	@Override
	public void select(String statement, ResultHandler handler) {
		wrappedSession.select(statement, handler);
	}

	@Override
	public void select(String statement, Object parameter, RowBounds rowBounds, ResultHandler handler) {
		wrappedSession.select(statement, parameter, rowBounds, handler);
	}

	@Override
	public int insert(String statement) {
		return wrappedSession.insert(statement);
	}

	@Override
	public int insert(String statement, Object parameter) {
		return wrappedSession.insert(statement, parameter);
	}

	@Override
	public int update(String statement) {
		return wrappedSession.update(statement);
	}

	@Override
	public int update(String statement, Object parameter) {
		return wrappedSession.update(statement, parameter);
	}

	@Override
	public int delete(String statement) {
		return wrappedSession.delete(statement);
	}

	@Override
	public int delete(String statement, Object parameter) {
		return wrappedSession.delete(statement, parameter);
	}

	@Override
	public void commit() {
		wrappedSession.commit();
	}

	@Override
	public void commit(boolean force) {
		wrappedSession.commit(force);
	}

	@Override
	public void rollback() {
		wrappedSession.rollback();
	}

	@Override
	public void rollback(boolean force) {
		wrappedSession.rollback(force);
	}

	@Override
	public List<BatchResult> flushStatements() {
		return wrappedSession.flushStatements();
	}

	@Override
	public void close() {
		wrappedSession.close();
	}

	@Override
	public void clearCache() {
		wrappedSession.clearCache();
	}

	@Override
	public Configuration getConfiguration() {
		return wrappedSession.getConfiguration();
	}

	@Override
	public <T> T getMapper(Class<T> type) {
		return wrappedSession.getMapper(type);
	}

	@Override
	public Connection getConnection() {
		return wrappedSession.getConnection();
	}

}
